---
layout: basic
---

# Preparation

## Create a means to keep track of links, hints, commands etc.

It is good practice to have a text file or word document open to which you can quickly store notes, links, commands, etc, so you can remember them later.  The notes don't have to be precise, just accurate enough to act as a reminder for what you learned and contain enough info that you can web search (or ask an AI assistant) for more details later.

## Create an account to access ChatGPT

See chatgpt [here](https://chat.openai.com/).  Make sure you have an account and can ask it questions.  The proper use of chatGPT for programmers is a topic of debate.  Do we want it writing code for us, code which we possibly don't understand?  Probably not.  However it is very useful as a means to create smaller code snippets, and remind us how to do things that we knew how to do once in that past**.

"the past" can be any time frame from decades ago, to something we learned 20 minutes ago but already forgot. 

## Anaconda

Install Anaconda from [here](https://www.anaconda.com/download)

#### What is Anaconda?  Why do I need this?

Anaconda is a popular open-source platform for data science, machine learning, and scientific computing. It provides a comprehensive ecosystem that includes a package manager, a distribution of popular programming languages (Python and R), and a wide range of libraries and tools for data analysis, numerical computation, machine learning, and more.

Perhaps most importantly Anaconda comes with a package manager called 'conda'.  We will use conda to install tools for data science.

## Git for Windows  

Install git for windows from [here](https://gitforwindows.org/).

#### What is git?  Why do I need this

Git is a source control tool.  It allows you to checkpoint your programming work and go back to old versions if needed.  There are also cloud services that allow you to store git repositories.  

##  Get a github account 

Go to www.github.com and get an account.  Github is a web site that allows you to store and share your git code repositories.

## Download and install Visual Studio Code

Go get Visual Studio Code from [here](https://code.visualstudio.com/)

#### Why do I need Visual Studio Code

Visual Studio Code is an IDE (Integrated Development Environment).  You will use it as a means to edit your code files, run and debug them. 



